;##########################################################################
; Listview Template
;##########################################################################

ListViewSelectAll		    PROTO :DWORD ; Place wherever
ListViewGridlines		    PROTO :DWORD ; Place wherever
ListViewCheckboxes		    PROTO :DWORD ; Place wherever 
ListViewClearAll		    PROTO :DWORD ; Place wherever

ListViewInsertItem		    PROTO :DWORD, :DWORD, :DWORD, :DWORD
ListViewInsertSubItem	    PROTO :DWORD, :DWORD, :DWORD, :DWORD

ListViewSetCheckBox		    PROTO :DWORD, :DWORD
ListViewUnSetCheckBox	    PROTO :DWORD, :DWORD
ListViewToggleCheckBox      PROTO :DWORD, :DWORD
    
ListViewSetSelection	    PROTO :DWORD, :DWORD
ListViewGetSelection	    PROTO :DWORD	

ListViewGetItemText		    PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
ListViewSetItemText		    PROTO :DWORD, :DWORD, :DWORD, :DWORD

ListViewSetItemIcon		    PROTO :DWORD, :DWORD, :DWORD
ListViewGetItemIcon		    PROTO :DWORD, :DWORD, :DWORD

ListViewSetItemParam	    PROTO :DWORD, :DWORD, :DWORD
ListViewGetItemParam	    PROTO :DWORD, :DWORD

ListViewSubClass            PROTO :DWORD, :DWORD
ListViewSubClassProc        PROTO :DWORD, :DWORD, :DWORD, :DWORD

ListViewDisableColumnResizing PROTO :DWORD
ListViewHeaderProc          PROTO :DWORD, :DWORD, :DWORD, :DWORD

ListViewDropDownListMode    PROTO :DWORD, :DWORD, :DWORD, :DWORD ; Place in WM_NOTIFY:NM_CLICK
ListViewDropDownListProc    PROTO :DWORD, :DWORD, :DWORD, :DWORD

ListViewDropDownMode        PROTO :DWORD, :DWORD, :DWORD, :DWORD ; Place in WM_NOTIFY:NM_CLICK
ListViewDropDownProc        PROTO :DWORD, :DWORD, :DWORD, :DWORD
ListViewDropDownEditProc    PROTO :DWORD, :DWORD, :DWORD, :DWORD

include windows.inc
include kernel32.inc
Include gdi32.inc		    ; For Font
Include Comctl32.inc	    ; For listview control
Include	ole32.inc		    ; For COM/OLE - listview image

includelib kernel32.lib
includelib gdi32.lib		; For Font
includelib Comctl32.lib		; For listview control
includelib ole32.lib		; For COM/OLE - listview image

;--------------------------------------------------------------------------
; Subclass data to pass onto subclassed listview
LISTVIEWSUBCLASSDATA    STRUCT
    pListViewOldProc    dd 0
    hParent             dd 0
LISTVIEWSUBCLASSDATA    ENDS

NMLVDISPINFOA           STRUCT
    hdr                 NMHDR <>
    item                LVITEM <>
NMLVDISPINFOA           ENDS

;--------------------------------------------------------------------------
; Subclass data to pass onto subclassed combobox in listview
CBDATA                  STRUCT
	pOldProc	        DD 0            ; Pointer to old combobox procedure
	hParent		        DD 0            ; Parent - listview
	iItem		        DD 0            ; Current iItem in listview
	iSubitem	        DD 0            ; Current iSubItem in listview
	fType		        DD 0            ;
	szText              DB 256 DUP (0)  ; Current text of iItem+iSubItem
CBDATA                  ENDS

;--------------------------------------------------------------------------
; Subclass data to pass onto subclassed editbox portion of combobox in listview
EBDATA                  STRUCT
	pOldProc	        DD 0            ; Pointer to old editbox procedure
	hParent		        DD 0            ; Parent - listview
	iItem		        DD 0            ; Current iItem in listview
	iSubitem	        DD 0            ; Current iSubItem in listview
	szText              DB 256 DUP (0)  ; Current text of iItem+iSubItem
EBDATA                  ENDS

;--------------------------------------------------------------------------
; GetComboBoxInfo data structure to get parts of dropdown combo
COMBOBOXINFO            STRUCT
    cbSize              DD 0
    rcItem              RECT <>
    rcButton            RECT <>
    stateButton         DD 0
    hwndCombo           DD 0
    hwndItem            DD 0
    hwndList            DD 0
COMBOBOXINFO            ENDS

;--------------------------------------------------------------------------
; TEXT Macro
;--------------------------------------------------------------------------
CTEXT MACRO Text
    LOCAL szText
    .data
    szText byte Text, 0
    .code
    EXITM <offset szText>   
ENDM

.CONST

.DATA
hwndLVBrush             DD 0
pListviewHeaderOldProc  DD 0 ; for disabling resize of listview columns - calls default proc from subclass proc

CboDD                   CBDATA <> ; Custom data to pass onto subclass of Combo Dropdown
CboDDL			        CBDATA <> ; Custom data to pass onto subclass of Combo Dropdown List
CboDD_EditBox           EBDATA <> ; Custom data to pass onto subclass of Combo Dropdown's Editbox portion of its control
pcbi                    COMBOBOXINFO <> ; To get combobox info


.DATA?
hCboDD                  DD ? ; Handle to DropDown ComboBox
hCboDDL                 DD ? ; Handle to DropDownList ComboBox
hCboDD_Combo            DD ? ; Handle to combo part of ComboBox
hCboDD_EditBox          DD ? ; Handle to edit control part of ComboBox
hCboDD_List             DD ? ; Handle to list part of ComboBox


.CODE

;**************************************************************************	
; Select all items in listview
;**************************************************************************	
ListViewSelectAll		PROC	hListview:DWORD
	LOCAL LVItem:LV_ITEM
	
	; Deselect everything first
	mov LVItem.stateMask,LVIS_SELECTED
	mov LVItem.state,NULL
	invoke SendMessage,hListview,LVM_SETITEMSTATE,-1,ADDR LVItem
	
	; Select everything
	mov LVItem.stateMask,LVIS_SELECTED
	mov LVItem.state,LVIS_SELECTED
	invoke SendMessage,hListview,LVM_SETITEMSTATE,-1,ADDR LVItem
	ret
ListViewSelectAll 		ENDP


;**************************************************************************	
; Toggles Listview Gridlines On/Off
;**************************************************************************	
ListViewGridlines		PROC	hListview:DWORD
	
	; Get current extended styles like gridlines
	Invoke SendMessage, hListview, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0
	mov edx, LVS_EX_GRIDLINES ; gridlines
	xor eax, edx ; Toggle gridlines on/off
	Invoke SendMessage, hListview, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax ; Do It
	ret
ListViewGridlines 		ENDP


;**************************************************************************	
; Toggles Checkbox Column  On/Off
;**************************************************************************
ListViewCheckboxes	PROC	hListview:DWORD

	; Get current extended styles like gridlines
	Invoke SendMessage, hListview, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0	
	mov edx, LVS_EX_CHECKBOXES ; Checkboxes
	xor eax, edx ; Toggle checkboxes on/off
	Invoke SendMessage, hListview, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax ; Do It	
	ret
ListViewCheckboxes endp	


;**************************************************************************
; Inserts an item into the listbox. Start with 0 as 0 based index for items
;**************************************************************************
ListViewInsertItem	PROC	hListview:DWORD, nItem:DWORD, lpszItemText:DWORD, nItemImage:DWORD
	LOCAL LVItem:LV_ITEM
	.IF nItemImage != 0
    	mov LVItem.imask, LVIF_TEXT or LVIF_IMAGE
	.ELSE
	    mov LVItem.imask, LVIF_TEXT        
	.ENDIF
	mov eax, nItem
	mov LVItem.iItem, eax	
	mov LVItem.iSubItem, 0
	mov LVItem.state, LVIS_FOCUSED
	mov LVItem.stateMask, 0
	mov eax, lpszItemText
	mov LVItem.pszText, eax
	Invoke lstrlen, lpszItemText
	mov LVItem.cchTextMax, eax
	.IF nItemImage != 0
	    mov eax, nItemImage
	    mov LVItem.iImage, eax
	.ENDIF
	mov LVItem.lParam, 0
	invoke SendMessage, hListview, LVM_INSERTITEM, 0, Addr LVItem
	mov eax, LVItem.iItem
	ret
ListViewInsertItem endp


;**************************************************************************
; Inserts an Sub-item into the listbox. Start with 1 as 1 based index for sub items
;**************************************************************************
ListViewInsertSubItem	PROC hListview:DWORD, nItem:DWORD, nSubItem:DWORD, lpszItemText:DWORD
    LOCAL LVItem:LV_ITEM
	mov LVItem.imask, LVIF_TEXT
	mov eax, nItem
	mov LVItem.iItem, eax
	mov eax, nSubItem
	mov LVItem.iSubItem, eax
    mov eax, lpszItemText
	mov LVItem.pszText, eax
	invoke SendMessage, hListview, LVM_SETITEM, 0, addr LVItem
	mov eax, LVItem.iItem	
	ret
ListViewInsertSubItem endp


;**************************************************************************
; Gets the text of the specified index. 
;**************************************************************************
ListViewGetItemText		PROC hListview:DWORD, nItem:DWORD, nSubItem:DWORD, lpszItemText:DWORD, lpszItemTextSize:DWORD
	LOCAL LVItem:LV_ITEM
	mov LVItem.imask, LVIF_TEXT
	mov eax, nItem
	mov LVItem.iItem, eax	
	mov eax, nSubItem
	mov LVItem.iSubItem, eax
    mov eax, lpszItemText
	mov LVItem.pszText, eax	
	mov eax, lpszItemTextSize
	mov LVItem.cchTextMax, eax	
	invoke SendMessage, hListview, LVM_GETITEMTEXT, nItem, Addr LVItem
	ret
ListViewGetItemText endp


;**************************************************************************
; Sets the icon of the specified index. 
;**************************************************************************
ListViewSetItemIcon		PROC hListview:DWORD, nItem:DWORD, nIcon:DWORD
	LOCAL LVItem:LV_ITEM
	mov LVItem.imask, LVIF_IMAGE	
	mov eax, nIcon
	mov LVItem.iImage, eax
	invoke SendMessage, hListview, LVM_SETITEM, nItem, Addr LVItem
	ret
ListViewSetItemIcon endp


;**************************************************************************
; Sets the text of the specified index. 
;**************************************************************************
ListViewSetItemText		PROC hListview:DWORD, nItem:DWORD, nSubItem:DWORD, lpszItemText:DWORD
	LOCAL LVItem:LV_ITEM
	mov LVItem.imask, LVIF_TEXT
	mov eax, nItem
	mov LVItem.iItem, eax
	mov eax, nSubItem
	mov LVItem.iSubItem, eax
    mov eax, lpszItemText
	mov LVItem.pszText, eax
	Invoke lstrlen, lpszItemText
	mov LVItem.cchTextMax, eax	
	mov LVItem.lParam, 0	
	invoke SendMessage, hListview, LVM_SETITEMTEXT, nItem, Addr LVItem
	ret
ListViewSetItemText endp


;**************************************************************************
; Sets the lParam of the specified index. ParamValue is a 32bit dword value
;**************************************************************************
ListViewSetItemParam	PROC hListview:DWORD, nItem:DWORD, ParamValue:DWORD
	LOCAL LVItem:LV_ITEM
	mov LVItem.imask,LVIF_PARAM
	mov eax, nItem
	mov LVItem.iItem, eax
	mov LVItem.iSubItem,0 
	mov eax, ParamValue
	push eax
	pop LVItem.lParam
	invoke SendMessage, hListview, LVM_SETITEM, 0, Addr LVItem
	ret
ListViewSetItemParam endp


;**************************************************************************
; Gets the lParam of the specified index. ParamValue is a 32bit dword value
; Returns the value in eax.
;**************************************************************************
ListViewGetItemParam	PROC	hListview:DWORD, nItem:DWORD
    LOCAL LVItem:LV_ITEM
	mov LVItem.imask,LVIF_PARAM
	mov eax, nItem
	mov LVItem.iItem, eax
	mov LVItem.iSubItem,0 
	invoke SendMessage, hListview, LVM_GETITEM, nItem, Addr LVItem
	.iF eax == TRUE
		mov eax, LVItem.lParam
	.ELSE
		mov eax, -1
	.ENDIF
	ret
ListViewGetItemParam	ENDP


;**************************************************************************
; Set an Listitem checkbox. nItem is the 0 based index to specify.
;**************************************************************************
ListViewSetCheckBox	PROC hListview:DWORD, nItem:DWORD
	LOCAL LVItem:LV_ITEM
	mov eax, nItem
	mov LVItem.iItem, eax
	mov LVItem.iSubItem, 0
	mov LVItem.imask, LVIF_STATE
	mov LVItem.stateMask, LVIS_STATEIMAGEMASK
	xor eax, eax
	mov eax,2                     ; set check
	shl eax,12	
	mov LVItem.state, eax
	Invoke SendMessage, hListview, LVM_SETITEMSTATE, nItem, addr LVItem
	ret
ListViewSetCheckBox endp


;**************************************************************************
; Set an Listitem checkbox. nItem is the 0 based index to specify.
;**************************************************************************
ListViewUnSetCheckBox	PROC hListview:DWORD, nItem:DWORD
	LOCAL LVItem:LV_ITEM
	mov eax, nItem
	mov LVItem.iItem, eax	
	mov LVItem.iSubItem, 0
	mov LVItem.imask, LVIF_STATE
	mov LVItem.stateMask, LVIS_STATEIMAGEMASK
	xor eax, eax
	mov eax,1                     ; unset check
	shl eax,12	
	mov LVItem.state, eax
	Invoke SendMessage, hListview, LVM_SETITEMSTATE, nItem, addr LVItem
	ret
ListViewUnSetCheckBox endp


;**************************************************************************	
; Toggles the Listitem checkbox. nItem is the 0 based index to specify.
;**************************************************************************	
ListViewToggleCheckBox  PROC hListview:DWORD, nItem:DWORD
	LOCAL LVItem:LV_ITEM
	mov eax, nItem
	mov LVItem.iItem, eax	
	mov LVItem.iSubItem, 0
	mov LVItem.imask, LVIF_STATE
	mov LVItem.stateMask, LVIS_STATEIMAGEMASK
	xor eax, eax
	mov LVItem.state, eax
	Invoke SendMessage, hListview, LVM_GETITEMSTATE, nItem, addr LVItem
    and eax, (3 SHL 12)
    .if(eax==(2 SHL 12))    ; If checked item 
	    xor eax, eax
	    mov eax,1                     ; unset check
	    shl eax,12	
	    mov LVItem.state, eax
	.ELSE
    	xor eax, eax
    	mov eax,2                     ; set check
    	shl eax,12	
    	mov LVItem.state, eax    
    .ENDIF    
	Invoke SendMessage, hListview, LVM_SETITEMSTATE, nItem, addr LVItem
    ret
ListViewToggleCheckBox endp


;**************************************************************************	
; Set the currently selected item to a specified index
;**************************************************************************	
ListViewSetSelection	PROC hListview:DWORD, nItemIndex:DWORD
	LOCAL LVItem:LV_ITEM
	; Release current focus
	mov LVItem.state, 0
	mov LVItem.stateMask, LVIS_SELECTED + LVIS_FOCUSED
	invoke SendMessage, hListview, LVM_SETITEMSTATE, -1, addr LVItem

	; Set current focus
	mov LVItem.state, LVIS_SELECTED + LVIS_FOCUSED
	mov LVItem.stateMask, LVIS_SELECTED + LVIS_FOCUSED
	invoke SendMessage, hListview, LVM_SETITEMSTATE, nItemIndex, addr LVItem
	ret
ListViewSetSelection endp


;**************************************************************************	
; Get Index of Currently Selected Item in Listview
;**************************************************************************	
ListViewGetSelection	PROC hListview:DWORD
	Invoke SendMessage, hListview, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
	ret
ListViewGetSelection endp


;**************************************************************************	
; Delete all data from listview
;**************************************************************************	
ListViewClearAll	PROC	hListview:DWORD
	
	; Clear all list items
	Invoke SendMessage, hListview, LVM_DELETEALLITEMS, 0, 0
	ret
ListViewClearAll endp


;**************************************************************************	
; For subclassing listview header. Used with
;**************************************************************************	
ListViewDisableColumnResizing  PROC    hListview:DWORD
    
    invoke GetWindow, hListview, GW_CHILD
    Invoke SetWindowLong, eax, GWL_WNDPROC, OFFSET ListViewHeaderProc
    ;invoke SetWindowLong, hListview, GWL_USERDATA, eax
    mov pListviewHeaderOldProc, eax
    ret

ListViewDisableColumnResizing endp

;**************************************************************************	
; To disable listview column resizing
;**************************************************************************	
ListViewHeaderProc  PROC hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    .if uMsg==WM_LBUTTONDOWN
	    ;invoke GetWindowLong, hWin, GWL_USERDATA
	    ;invoke CallWindowProc, eax, hWin, NULL, NULL, NULL   
        invoke CallWindowProc, pListviewHeaderOldProc, hWin, NULL, NULL, NULL
        ret
    .elseif uMsg==WM_SETCURSOR
	    ;invoke GetWindowLong, hWin, GWL_USERDATA
	    ;invoke CallWindowProc, eax, hWin, NULL, NULL, NULL       
        invoke CallWindowProc, pListviewHeaderOldProc, hWin, NULL, NULL, NULL
        ret
    .else
	    ;invoke GetWindowLong, hWin, GWL_USERDATA
	    ;invoke CallWindowProc, eax, hWin, uMsg, wParam, lParam     
        invoke CallWindowProc, pListviewHeaderOldProc, hWin, uMsg, wParam, lParam

    .endif
    ret
ListViewHeaderProc  ENDP


;**************************************************************************	
; Subclass a listview. ListViewSubClassProc is Offset to proc, example:
;
; Invoke ListViewSubClass, hMyLV, OFFSET MyListViewProc
; mov pListViewSubClassProc, eax
;
; Returns pointer to old subclass procedure, save this in a variable
; and use it in your subclass proc to call default at end of proc:
; 
; Invoke CallWindowProc,pListViewSubClassProc,hWin,iMsg,wParam,lParam
; 
;**************************************************************************	
ListViewSubClass    PROC    hListview:DWORD, LVSCData:DWORD

	invoke SetWindowLong,hListview, GWL_WNDPROC, Offset ListViewSubClassProc
    mov ebx, LVSCData
    mov [ebx+LISTVIEWSUBCLASSDATA.pListViewOldProc], eax
    mov eax, hListview
    mov [ebx+LISTVIEWSUBCLASSDATA.hParent], eax
	;mov pListViewLangSubClass,eax
    invoke SetWindowLong,hListview,GWL_USERDATA, LVSCData
    
	invoke CreateSolidBrush,00C56A31h ;brush for the listview
	mov hwndLVBrush,eax
    ret

ListViewSubClass endp


;-------------------------------------------------------------------------------------
; Sublass for Listview to handle custom combobox in place editing of listview cells
;-------------------------------------------------------------------------------------
ListViewSubClassProc    PROC hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL pt:POINT
	LOCAL szTextBuffer[256]:BYTE

	mov eax, uMsg
    .if eax==WM_DRAWITEM
		mov edi,lParam
		mov eax, [edi.DRAWITEMSTRUCT.hwndItem] 
		.IF eax == hCboDDL
			mov byte ptr [szTextBuffer], 0
			mov ebx,[edi+DRAWITEMSTRUCT.itemState]
			mov eax,[edi+DRAWITEMSTRUCT.itemAction]

			AND ebx, ODS_COMBOBOXEDIT ; do this to just check if we are in the edit portion of the combo
			.IF ebx == ODS_COMBOBOXEDIT 
			    ;PrintText 'Selected'
    			invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],00FFFFFFh
	    		mov ecx,edi
		    	add ecx,DRAWITEMSTRUCT.rcItem
			    invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ecx,hwndLVBrush			    
			.ELSE

    			.IF eax == ODA_FOCUS ; if item is being focused as mouse moves over comboitem, we draw with navy rectangle and white text
        			invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],00FFFFFFh
    	    		mov ecx,edi
    		    	add ecx,DRAWITEMSTRUCT.rcItem
    			    invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ecx,hwndLVBrush
    			.ELSE ; otherwise its just black on white text
        			invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],00000000h
    	    		invoke GetStockObject,WHITE_BRUSH
    		    	mov ecx,edi
    			    add ecx,DRAWITEMSTRUCT.rcItem
    			    invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ecx,eax
    			.ENDIF
    		.ENDIF	
			invoke SetBkMode,[edi+DRAWITEMSTRUCT.hdc],TRANSPARENT
			
			invoke SendMessage,[edi+DRAWITEMSTRUCT.hwndItem],CB_GETLBTEXT,[edi+DRAWITEMSTRUCT.itemID],Addr szTextBuffer
			
			mov eax,edi
			add eax,DRAWITEMSTRUCT.rcItem
			invoke DrawText,[edi+DRAWITEMSTRUCT.hdc],Addr szTextBuffer,-1,eax,DT_LEFT+DT_SINGLELINE+DT_VCENTER
			xor eax,eax
			inc eax
			ret
		.ENDIF

	.ELSEIF eax == WM_MEASUREITEM
		; Measurements for the combo box
		mov edi,lParam
		mov eax, [edi.DRAWITEMSTRUCT.hwndItem] 
		.IF eax == hCboDDL
			;Find the DC for the combo box and get the text height
			invoke GetDC, hCboDDL
			mov esi,eax ; ESI holds the DC
			; Just get the height for a single item
			; Owner drawn fixed only sends the message once
			; so it really makes no difference what text we use
			invoke GetTextExtentPoint32,esi,CTEXT("Hello"),5, Addr pt
			; Release the DC
			invoke ReleaseDC,hCboDDL,esi
			mov eax,[pt.y]
			mov [edi+MEASUREITEMSTRUCT.itemHeight],eax
			xor eax,eax
			inc eax
			ret
        .ENDIF
	
		
	.ELSE
	    invoke GetWindowLong, hWin, GWL_USERDATA
	    invoke CallWindowProc, [eax+LISTVIEWSUBCLASSDATA.pListViewOldProc], hWin, uMsg, wParam, lParam
	.ENDIF
    ret

ListViewSubClassProc endp


;-------------------------------------------------------------------------------------
; Creates a CBS_DROPDOWNLIST ComboBox. We then subclass it
;
; hListview param is the listview
;
; ComboDDLResID param is the ComboBox Resource ID used to identify the ComboBox created
;
; iItem and iSubItem params are the currently clicked listview item & subitem
;
; The ComboBox is created and placed over the bounding rectangle of the currently 
; selected listview item & subitem.  ListViewDropDownListProc is the subclass procedure 
;
; Called from WM_NOTIFY:NM_CLICK 
;-------------------------------------------------------------------------------------
ListViewDropDownListMode    PROC    hListview:DWORD, ComboDDLResID:DWORD, iItem:DWORD, iSubItem:DWORD
    LOCAL szTextBuffer[MAX_PATH]:byte
    LOCAL rect:RECT

	.IF iSubItem == 0 ; LVM_GETSUBITEMRECT doesnt work with iSubItem == 0 so we calc it another way
	    mov rect.left, LVIR_BOUNDS
	    Invoke SendMessage, hListview, LVM_GETITEMRECT, iItem, Addr rect 
	    Invoke SendMessage, hListview, LVM_GETCOLUMNWIDTH, 0, 0
	    mov rect.right, eax
	.ELSE
    	mov eax, iSubItem
    	mov rect.top, eax
    	mov rect.left, LVIR_BOUNDS
    	Invoke SendMessage, hListview, LVM_GETSUBITEMRECT, iItem, Addr rect
    .ENDIF

    ; Stuff for calculating the exact positioning of where we are going to create our combobox
;	inc rect.left
;	inc rect.left
;	mov eax, rect.right
;	sub eax, rect.left
;	mov rect.right, eax
;	mov eax, rect.bottom
;	sub eax, rect.top
;	push eax
;	mov rect.bottom, eax
;	mov ecx, rect.bottom
;	shl ecx, 3	
	
    dec rect.top
	inc rect.left
	inc rect.left
	mov eax, rect.right
	sub eax, rect.left
	mov rect.right, eax
	mov eax, rect.bottom
	sub eax, rect.top
	push eax
	mov rect.bottom, eax
	mov ecx, rect.bottom
	shl ecx, 3	
	mov rect.bottom, ecx	
	
	; Create our combobox
	;invoke CreateWindowEx,NULL,CTEXT("ComboBox"),NULL,WS_CHILD+WS_VISIBLE+CBS_DROPDOWNLIST+CBS_HASSTRINGS+WS_TABSTOP+WS_CLIPCHILDREN+CBS_AUTOHSCROLL+WS_VSCROLL,rect.left,rect.top,rect.right,rect.bottom,hListview,ComboDDLResID,hInstance,NULL
    invoke CreateWindowEx,NULL,CTEXT("ComboBox"),NULL,CBS_OWNERDRAWFIXED+WS_CHILD+WS_VISIBLE+CBS_DROPDOWNLIST+CBS_HASSTRINGS+WS_TABSTOP+CBS_AUTOHSCROLL+WS_VSCROLL,rect.left,rect.top,rect.right,rect.bottom,hListview,ComboDDLResID,hInstance,NULL	
    mov hCboDDL, eax ; save handle to a global var - which is re-used for any CBS_DROPDOWNLIST style combos we create
	invoke SendMessage, hListview, WM_GETFONT, 0, 0
	invoke SendMessage, hCboDDL, WM_SETFONT, eax, 0 ; set font same as listview has
	invoke SetWindowPos, hCboDDL, HWND_TOP, 0,0,0,0, SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE
	
	pop eax
	sub eax,4
    invoke SendMessage,hCboDDL,CB_SETITEMHEIGHT,-1,eax
    
    ; Get the actual text in listview at the current iItem & iSubItem
    Invoke ListViewGetItemText, hListview, iItem, iSubItem, Addr szTextBuffer, SIZEOF szTextBuffer
    
    invoke SetWindowLong,hCboDDL, GWL_WNDPROC, OFFSET ListViewDropDownListProc ; subclass the combo itself
    mov CboDDL.pOldProc, eax
    mov eax, hListview
	mov CboDDL.hParent, eax
	mov eax, iItem
	mov CboDDL.iItem, eax
	mov eax, iSubItem
	mov CboDDL.iSubitem, eax
	mov CboDDL.fType, 0
	lea eax, szTextBuffer
	Invoke lstrcpyn, Addr CboDDL.szText, eax, MAX_PATH
    invoke SetWindowLong,hCboDDL, GWL_USERDATA, OFFSET CboDDL ; pass on saved info to our subclass of combo, so we can reference it in our sublcass procs later on
    invoke SetFocus, hCboDDL


    
    ret
ListViewDropDownListMode    ENDP


;-------------------------------------------------------------------------------------
; Subclass of the DropDownList ComboBox (NO EDIT CONTROL IN THIS ONE - JUST A LIST)
;
; If user presses ESC, TAB or ENTER we quit out. By initialing the subclass with the
; listitem text in the ListViewDropDownListMode CBDATA.szText we can restore the text
; if user selects and item and then presses ESC, otherwise when control loses focus
; the listview item text has already been changed from CBN_SELCHANGE.
; 
; if user presses RETURN, we assume all is good and update listview item and quit
;
; if user presses TAB, we assume same as RETURN. In theory we could try and find
; next listview item or subitem and set focus there perhaps - maybe another time tho.
; 
; if focus is lost we destroy the combobox
;
;-------------------------------------------------------------------------------------
ListViewDropDownListProc    PROC    hWin:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
    LOCAL szTextBuffer[MAX_PATH]:byte
    LOCAL lvi:LV_ITEM
    LOCAL wNotify_code:DWORD
    
    mov eax, uMsg
    
    .if eax == WM_KILLFOCUS
		Invoke DestroyWindow, hCboDDL

    .ELSEIF eax==WM_COMMAND
		mov eax, wParam
		shr eax, 16
		mov wNotify_code, eax    
		mov		eax,wParam
		and		eax,0FFFFh
	    .IF wNotify_code == CBN_SELCHANGE
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax
    		mov eax, [ebx+CBDATA.fType]
    		.IF eax == 0
    			invoke SendMessage,hWin,CB_GETCURSEL,0,0
    			.IF eax != CB_ERR
    			    mov ecx, eax
    				invoke SendMessage,hWin,CB_GETLBTEXT, ecx, Addr szTextBuffer
    				
    				mov eax,[ebx+CBDATA.iItem]
    				mov lvi.iItem,eax
    				mov eax,[ebx+CBDATA.iSubitem]
    				mov lvi.iSubItem,eax
    				mov lvi.imask,LVIF_TEXT
    				lea eax, szTextBuffer
    				mov lvi.pszText, eax
    				invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem], Addr lvi
                .ENDIF
    	    .ENDIF
        .ENDIF
	    invoke GetWindowLong, hWin, GWL_USERDATA
	    invoke CallWindowProc, [eax+CBDATA.pOldProc], hWin, uMsg, wParam, lParam    	    
    	ret        
        
    .ELSEIF eax == WM_KEYDOWN
        .IF wParam == VK_ESCAPE
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax			
			lea eax,[ebx+CBDATA.szText]
			;PrintStringByAddr eax
			Invoke lstrcpyn, Addr szTextBuffer, eax, MAX_PATH
			mov eax,[ebx+CBDATA.iItem]
			mov lvi.iItem,eax
			mov eax,[ebx+CBDATA.iSubitem]
			mov lvi.iSubItem,eax
			mov lvi.imask,LVIF_TEXT
			lea eax, szTextBuffer
			mov lvi.pszText, eax
			invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem], Addr lvi        
            ;Invoke DestroyWindow, hCboDDL
            invoke SendMessage,hWin,WM_CLOSE,0,0
            ret
            
        .ELSEIF wParam == VK_TAB
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax
    		mov eax, [ebx+CBDATA.fType]
    		.IF eax == 0
    			invoke SendMessage,hWin,CB_GETCURSEL,0,0
    			.IF eax != CB_ERR
    			    mov ecx, eax
    				invoke SendMessage,hWin,CB_GETLBTEXT, ecx, Addr szTextBuffer
    				
    				mov eax,[ebx+CBDATA.iItem]
    				mov lvi.iItem,eax
    				mov eax,[ebx+CBDATA.iSubitem]
    				mov lvi.iSubItem,eax
    				mov lvi.imask,LVIF_TEXT
    				lea eax, szTextBuffer
    				mov lvi.pszText, eax
    				invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem], Addr lvi
                .ENDIF
    	    .ENDIF        
            invoke SendMessage,hWin,WM_CLOSE,0,0
            ret
            
        .ELSEIF wParam == VK_RETURN
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax
    		mov eax, [ebx+CBDATA.fType]
    		.IF eax == 0
    			invoke SendMessage,hWin,CB_GETCURSEL,0,0
    			.IF eax != CB_ERR
    			    mov ecx, eax
    				invoke SendMessage,hWin,CB_GETLBTEXT, ecx, Addr szTextBuffer
    				
    				mov eax,[ebx+CBDATA.iItem]
    				mov lvi.iItem,eax
    				mov eax,[ebx+CBDATA.iSubitem]
    				mov lvi.iSubItem,eax
    				mov lvi.imask,LVIF_TEXT
    				lea eax, szTextBuffer
    				mov lvi.pszText, eax
    				invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem], Addr lvi
                .ENDIF
    	    .ENDIF        
            invoke SendMessage,hWin,WM_CLOSE,0,0
            ret
            
        .ELSEIF wParam == VK_SPACE
            Invoke SendMessage, hWin, CB_SHOWDROPDOWN, TRUE, 0
            ret
        .ELSE
	        invoke GetWindowLong, hWin, GWL_USERDATA
	        invoke CallWindowProc, [eax+CBDATA.pOldProc], hWin, uMsg, wParam, lParam            
        .ENDIF
		    
	.else
	    invoke GetWindowLong, hWin, GWL_USERDATA
	    invoke CallWindowProc, [eax+CBDATA.pOldProc], hWin, uMsg, wParam, lParam
	.endif
	    
    ret

ListViewDropDownListProc    ENDP


;-------------------------------------------------------------------------------------
; Creates a CBS_DROPDOWN ComboBox - with an edit control. We then subclass the
; ComboBox and its Edit control seperately to allow us to handle it.
;
; hListview param is the listview
;
; ComboDDResID param is the ComboBox Resource ID used to identify the ComboBox created
;
; iItem and iSubItem params are the currently clicked listview item & subitem
;
; The ComboBox is created and placed over the bounding rectangle of the currently 
; selected listview item & subitem.  ListViewDropDownProc is the subclass procedure for
; the ComboBox and ListViewDropDownEditProc is the subclass procedure for handling the 
; Edit box portion of the ComboBox
;
; Called from WM_NOTIFY:NM_CLICK 
;-------------------------------------------------------------------------------------
ListViewDropDownMode    PROC    hListview:DWORD, ComboDDResID:DWORD, iItem:DWORD, iSubItem:DWORD
    LOCAL szTextBuffer[MAX_PATH]:byte
    LOCAL rect:RECT

	.IF iSubItem == 0 ; LVM_GETSUBITEMRECT doesnt work with iSubItem == 0 so we calc it another way
	    mov rect.left, LVIR_BOUNDS
	    Invoke SendMessage, hListview, LVM_GETITEMRECT, iItem, Addr rect 
	    Invoke SendMessage, hListview, LVM_GETCOLUMNWIDTH, 0, 0
	    mov rect.right, eax
	.ELSE
    	mov eax, iSubItem
    	mov rect.top, eax
    	mov rect.left, LVIR_BOUNDS
    	Invoke SendMessage, hListview, LVM_GETSUBITEMRECT, iItem, Addr rect
    .ENDIF

    ; Stuff for calculating the exact positioning of where we are going to create our combobox
    dec rect.top
	inc rect.left
	inc rect.left
	mov eax, rect.right
	sub eax, rect.left
	mov rect.right, eax
	mov eax, rect.bottom
	sub eax, rect.top
	push eax
	mov rect.bottom, eax
	mov ecx, rect.bottom
	shl ecx, 3	
	mov rect.bottom, ecx
	
    ; Create our combobox
	;invoke CreateWindowEx,NULL,CTEXT("ComboBox"),NULL,WS_CHILD+WS_VISIBLE+CBS_DROPDOWN+CBS_HASSTRINGS+WS_TABSTOP+WS_CLIPCHILDREN+WS_CLIPSIBLINGS+CBS_AUTOHSCROLL+WS_VSCROLL,rect.left,rect.top,rect.right,rect.bottom,hListview,ComboDDResID,hInstance,NULL
	invoke CreateWindowEx,NULL,CTEXT("ComboBox"),NULL,WS_CHILD+WS_VISIBLE+CBS_DROPDOWN+CBS_HASSTRINGS+WS_TABSTOP+CBS_AUTOHSCROLL+WS_VSCROLL,rect.left,rect.top,rect.right,rect.bottom,hListview,ComboDDResID,hInstance,NULL
	mov hCboDD, eax ; save handle to a global var - which is re-used for any CBS_DROPDOWN style combos we create
	invoke SendMessage, hListview, WM_GETFONT, 0, 0
	invoke SendMessage, hCboDD, WM_SETFONT, eax, 0 ; set font same as listview has
	invoke SetWindowPos, hCboDD, HWND_TOP, 0,0,0,0, SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE

	pop eax
	sub eax,4
    invoke SendMessage,hCboDD,CB_SETITEMHEIGHT,-1,eax
    
    ; Get constituent parts of the combo and save to global vars which we can use later
    mov pcbi.cbSize, sizeof COMBOBOXINFO
    Invoke GetComboBoxInfo, hCboDD, Addr pcbi
    mov eax, pcbi.hwndCombo
    mov hCboDD_Combo, eax
    mov eax, pcbi.hwndItem
    mov hCboDD_EditBox, eax
    mov eax, pcbi.hwndList
    mov hCboDD_List, eax
    
    ; Get the actual text in listview at the current iItem & iSubItem
    Invoke ListViewGetItemText, hListview, iItem, iSubItem, Addr szTextBuffer, SIZEOF szTextBuffer
    
    Invoke SetWindowLong, hCboDD_EditBox, GWL_WNDPROC, OFFSET ListViewDropDownEditProc ; subclass our edit box portion of the combo - need to do this for CBS_DROPDOWN style combos
    mov CboDD_EditBox.pOldProc, eax
    mov eax, hListview
    mov CboDD_EditBox.hParent, eax
    mov eax, iItem
    mov CboDD_EditBox.iItem, eax
    mov eax, iSubItem
    mov CboDD_EditBox.iSubitem, eax
	lea eax, szTextBuffer
	Invoke lstrcpyn, Addr CboDD_EditBox.szText, eax, MAX_PATH
    invoke SetWindowLong, hCboDD_EditBox, GWL_USERDATA, OFFSET CboDD_EditBox ; pass on saved info to our subclass of editbox, so we reference it in our subclass procs later
    
	invoke SendMessage, hCboDD_EditBox, EM_SETMARGINS, EC_LEFTMARGIN or EC_RIGHTMARGIN, 00020002h

    invoke SetWindowLong,hCboDD, GWL_WNDPROC, OFFSET ListViewDropDownProc ; subclass the combo itself
    mov CboDD.pOldProc, eax
    mov eax, hListview
	mov CboDD.hParent, eax
	mov eax, iItem
	mov CboDD.iItem, eax
	mov eax, iSubItem
	mov CboDD.iSubitem, eax
	mov CboDD.fType, 0    
    invoke SetWindowLong,hCboDD, GWL_USERDATA, OFFSET CboDD ; pass on saved info to our subclass of combo, so we can reference it in our sublcass procs later on
    invoke SetFocus, hCboDD
   
    ret
ListViewDropDownMode    ENDP


;-------------------------------------------------------------------------------------
; Subclass of the Dropdown ComboBox
;
; If user presses ESC, TAB or ENTER we quit out. By initialing the subclass with the
; listitem text in the ListViewDropDownMode CBDATA.szText we can restore the text
; if user selects and item and then presses ESC, otherwise when control loses focus
; the listview item text has already been changed from CBN_SELCHANGE.
; 
; if user presses RETURN, we assume all is good and update listview item and quit
;
; if user presses TAB, we assume same as RETURN. In theory we could try and find
; next listview item or subitem and set focus there perhaps - maybe another time tho.
; 
; Because of the way the CB_DROPDOWN style combo is made - which is combination of a list, 
; edit control and combo - once we lose focus of the combo portion to the edit portion 
; or the list portion we have to take this into account. Only once focus is lost 
; entirely to a new control can we actually destroy the dropdown combobox, for this 
; reason we force the focus to the listview control itself and allow control to end
; 
; For a combobox that is CB_DROPDOWNLIST style we dont have this problem and can destroy
; that control once it loses focus.
;-------------------------------------------------------------------------------------
ListViewDropDownProc    PROC    hWin:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
    LOCAL szTextBuffer[256]:BYTE
    LOCAL lvi:LV_ITEM
    LOCAL rc:RECT
    LOCAL wNotify_code:DWORD
    LOCAL pt:POINT
     
    mov eax, uMsg
    .IF eax == WM_KILLFOCUS ; if focus is lost, but to part of the CBS_DROPDOWN combo, we ignore and continue onward
        mov eax, wParam
        .IF eax == hCboDD_EditBox 
            ret
        .ELSEIF eax == hCboDD_Combo
            ret
        .ELSEIF eax == hCboDD_List
            ret
        .ELSE ; otherwise if focus is lost to another control altogether, then we actually do kill the combo
            Invoke DestroyWindow, hCboDD
        .ENDIF        


    .ELSEIF eax==WM_COMMAND
		mov eax, wParam
		shr eax, 16
		mov wNotify_code, eax    
		mov		eax,wParam
		and		eax,0FFFFh
	    .IF wNotify_code == CBN_SELCHANGE ; Combo change has been made so we update listview item with new text
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax
    		mov eax, [ebx+CBDATA.fType]
    		.IF eax == 0
    			invoke SendMessage,hWin,CB_GETCURSEL,0,0
    			.IF eax != CB_ERR
    			    mov ecx, eax
    				invoke SendMessage,hWin,CB_GETLBTEXT, ecx, Addr szTextBuffer
    				
    				mov eax,[ebx+CBDATA.iItem]
    				mov lvi.iItem,eax
    				mov eax,[ebx+CBDATA.iSubitem]
    				mov lvi.iSubItem,eax
    				mov lvi.imask,LVIF_TEXT
    				lea eax, szTextBuffer
    				mov lvi.pszText, eax
    				invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem], Addr lvi
                .ENDIF
    	    .ENDIF
        .ENDIF
	    invoke GetWindowLong, hWin, GWL_USERDATA
	    invoke CallWindowProc, [eax+CBDATA.pOldProc], hWin, uMsg, wParam, lParam    	    
    	ret        

  
    .ELSEIF eax == WM_KEYDOWN
        .IF wParam == VK_ESCAPE
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax			
			lea eax,[ebx+CBDATA.szText]
			;PrintStringByAddr eax
			Invoke lstrcpyn, Addr szTextBuffer, eax, MAX_PATH
			mov eax,[ebx+CBDATA.iItem]
			mov lvi.iItem,eax
			mov eax,[ebx+CBDATA.iSubitem]
			mov lvi.iSubItem,eax
			mov lvi.imask,LVIF_TEXT
			lea eax, szTextBuffer
			mov lvi.pszText, eax
			invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem], Addr lvi        
            ;Invoke DestroyWindow, hCboDDL
            invoke SendMessage,hWin,WM_CLOSE,0,0
            ret
            
        .ELSEIF wParam == VK_TAB
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax
    		mov eax, [ebx+CBDATA.fType]
    		.IF eax == 0
    			invoke SendMessage,hWin,CB_GETCURSEL,0,0
    			.IF eax != CB_ERR
    			    mov ecx, eax
    				invoke SendMessage,hWin,CB_GETLBTEXT, ecx, Addr szTextBuffer
    				
    				mov eax,[ebx+CBDATA.iItem]
    				mov lvi.iItem,eax
    				mov eax,[ebx+CBDATA.iSubitem]
    				mov lvi.iSubItem,eax
    				mov lvi.imask,LVIF_TEXT
    				lea eax, szTextBuffer
    				mov lvi.pszText, eax
    				invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem], Addr lvi
                .ENDIF
    	    .ENDIF        
            invoke SendMessage,hWin,WM_CLOSE,0,0
            ret
            
        .ELSEIF wParam == VK_RETURN
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax
    		mov eax, [ebx+CBDATA.fType]
    		.IF eax == 0
    			invoke SendMessage,hWin,CB_GETCURSEL,0,0
    			.IF eax != CB_ERR
    			    mov ecx, eax
    				invoke SendMessage,hWin,CB_GETLBTEXT, ecx, Addr szTextBuffer
    				
    				mov eax,[ebx+CBDATA.iItem]
    				mov lvi.iItem,eax
    				mov eax,[ebx+CBDATA.iSubitem]
    				mov lvi.iSubItem,eax
    				mov lvi.imask,LVIF_TEXT
    				lea eax, szTextBuffer
    				mov lvi.pszText, eax
    				invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem], Addr lvi
                .ENDIF
    	    .ENDIF        
            invoke SendMessage,hWin,WM_CLOSE,0,0
            ret
            
        .ELSE
	        invoke GetWindowLong, hWin, GWL_USERDATA
	        invoke CallWindowProc, [eax+CBDATA.pOldProc], hWin, uMsg, wParam, lParam            
        .ENDIF


    ; Had partial success with implementing ownerdrawn combo dropdown (with edit control) - stuff is here as the parent proc of the combo's list is the combo box proc
    ; and not the listview as i first thought.
    ; works but does not draw navy border over selected items as mouse moves over it, probably need more time to investigate it. To enable - add CBS_OWNERDRAWNFIXED to the
    ; style of the combo when creating - see proc above for that - and uncomment the lines below.

;    .ELSEIF eax==WM_DRAWITEM
;		mov edi,lParam
;		mov eax, [edi.DRAWITEMSTRUCT.hwndItem] 
;		.IF eax == hCboDD_List
;			mov byte ptr [szTextBuffer], 0
;			mov eax,[edi+DRAWITEMSTRUCT.itemAction]
;			mov ebx,[edi+DRAWITEMSTRUCT.itemState]
;			AND eax, ODA_SELECT
;			.IF eax == ODA_SELECT ; if item is being focused as mouse moves over comboitem, we draw with navy rectangle and white text
;    			invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],00FFFFFFh
;	    		mov ecx,edi
;		    	add ecx,DRAWITEMSTRUCT.rcItem
;			    invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ecx,hwndLVBrush
;			.ELSE ; otherwise its just black on white text
;			    ;PrintDec eax
;			   ; PrintDec ebx
;    			invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],00000000h
;	    		invoke GetStockObject,WHITE_BRUSH
;		    	mov ecx,edi
;			    add ecx,DRAWITEMSTRUCT.rcItem
;			    invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ecx,eax
;			.ENDIF
;			invoke SetBkMode,[edi+DRAWITEMSTRUCT.hdc],TRANSPARENT
;			
;			invoke SendMessage,hCboDD,CB_GETLBTEXT,[edi+DRAWITEMSTRUCT.itemID],Addr szTextBuffer
;			;PrintString szTextBuffer
;			mov eax,edi
;			add eax,DRAWITEMSTRUCT.rcItem
;			invoke DrawText,[edi+DRAWITEMSTRUCT.hdc],Addr szTextBuffer,-1,eax,DT_LEFT+DT_SINGLELINE+DT_VCENTER
;			xor eax,eax
;			inc eax
;			ret
;				
;		.ENDIF
;
;	.ELSEIF eax == WM_MEASUREITEM
;		; Measurements for the combo box
;		mov edi,lParam
;		mov eax, [edi.DRAWITEMSTRUCT.hwndItem] 
;		.IF eax == hCboDD_List
;			;Find the DC for the combo box and get the text height
;			invoke GetDC, hCboDD_List
;			mov esi,eax ; ESI holds the DC
;			; Just get the height for a single item
;			; Owner drawn fixed only sends the message once
;			; so it really makes no difference what text we use
;			invoke GetTextExtentPoint32,esi,CTEXT("Hello"),5, Addr pt
;			; Release the DC
;			invoke ReleaseDC,hCboDD_List,esi
;			mov eax,[pt.y]
;			mov [edi+MEASUREITEMSTRUCT.itemHeight],eax
;			xor eax,eax
;			inc eax
;			ret
;        .ENDIF
  
    ; dont think we need this, havent noticed anything going wrong without it
;	.ELSEIF eax == WM_SIZE
;        invoke GetWindowLong, hWin, GWL_USERDATA
;		invoke CallWindowProc, [eax+CBDATA.pOldProc], hWin, uMsg, wParam, lParam
;
;		invoke GetWindowRect, hCboDD, addr rc
;		invoke ScreenToClient, hWin, addr rc.left
;		invoke ScreenToClient, hWin, addr rc.right
;		mov ecx, rc.bottom
;		add ecx, rc.top
;		invoke SetWindowPos, hCboDD, NULL, 0, 0, rc.right, ecx, SWP_NOZORDER 
		   	
	.ELSE
	    invoke GetWindowLong, hWin, GWL_USERDATA
	    invoke CallWindowProc, [eax+CBDATA.pOldProc], hWin, uMsg, wParam, lParam
	.ENDIF
	    
    ret

ListViewDropDownProc    ENDP


;-------------------------------------------------------------------------------------
; Subclass of the Dropdown ComboBox's edit control
;
; If user presses ESC, TAB or ENTER we quit out. By initialing the subclass with the
; listitem text in the ListViewDropDownMode CBDATA.szText we can restore the text
; if user selects and item and then presses ESC, otherwise when control loses focus
; the listview item text has already been changed from CBN_SELCHANGE.
; 
; if user presses RETURN, we assume all is good and update listview item and quit
;
; if user presses TAB, we assume same as RETURN. In theory we could try and find
; next listview item or subitem and set focus there perhaps - maybe another time tho.
; 
; Because of the way the CB_DROPDOWN style combo is made - which is combination of a list, 
; edit control and combo - once we lose focus of the combo portion to the edit portion 
; or the list portion we have to take this into account. Only once focus is lost 
; entirely to a new control can we actually destroy the dropdown combobox, for this 
; reason we force the focus to the listview control itself and allow control to end
; 
; For a combobox that is CB_DROPDOWNLIST style we dont have this problem and can destroy
; that control once it loses focus.
;
;-------------------------------------------------------------------------------------
ListViewDropDownEditProc    PROC    hWin:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
    LOCAL szTextBuffer[MAX_PATH]:byte
    LOCAL lvi:LV_ITEM
    LOCAL wNotify_code:DWORD
    LOCAL pt:POINT
    
    mov eax, uMsg
   
    .if eax == WM_KILLFOCUS ; if focus is lost, but to part of the CBS_DROPDOWN combo, we ignore and continue onward
        mov eax, wParam 
        .IF  eax == hCboDD_EditBox
            ret
            
        .ELSEIF eax == hCboDD_Combo
	        ret        

        .ELSEIF eax == hCboDD_List
	        ret        

        .ELSE ; otherwise if focus is lost to another control altogether, then we actually do kill the combo
            Invoke DestroyWindow, hCboDD 
            ret
        .ENDIF   
    
;    .ELSEIF eax == WM_LBUTTONDBLCLK ; To try and force dropdown to show Doesnt show arrow cursor - tried loading cursor etc but doesnt work right
;       invoke GetWindowLong, hWin, GWL_USERDATA
;	    invoke CallWindowProc, [eax+EBDATA.pOldProc], hWin, uMsg, wParam, lParam 
;	    Invoke SendMessage, hCboDD, CB_SHOWDROPDOWN, TRUE, 0
;       ret

        
    .ELSEIF eax == WM_KEYDOWN
        .IF wParam == VK_ESCAPE
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax			
			lea eax,[ebx+EBDATA.szText]
			Invoke lstrcpyn, Addr szTextBuffer, eax, MAX_PATH
			mov eax,[ebx+EBDATA.iItem]
			mov lvi.iItem,eax
			mov eax,[ebx+EBDATA.iSubitem]
			mov lvi.iSubItem,eax
			mov lvi.imask,LVIF_TEXT
			lea eax, szTextBuffer
			mov lvi.pszText, eax
			invoke SendMessage,[ebx+EBDATA.hParent],LVM_SETITEMTEXT,[ebx+EBDATA.iItem], Addr lvi        
            Invoke DestroyWindow, hCboDD
            Invoke SetFocus, [ebx+EBDATA.hParent] ; force focus to listview itself to allow us to quit out of combo
            ret
            
        .ELSEIF wParam == VK_TAB
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax
    		Invoke SendMessage, hCboDD, CB_GETDROPPEDSTATE, 0, 0 ; Check if list is open
    		.IF eax == FALSE
    		    Invoke SendMessage, hWin, WM_GETTEXT, MAX_PATH, Addr szTextBuffer ; if its not just get text from editbox
    		.ELSE
                invoke SendMessage,hCboDD,CB_GETCURSEL,0,0 ; otherwise get current selection from opened listbox
    			.IF eax != CB_ERR
    			    mov ecx, eax
    				invoke SendMessage,hCboDD,CB_GETLBTEXT, ecx, Addr szTextBuffer
    			.ELSE ; if for some reason no selection is made in open listbox assume its like escape/cancel - so just do that instead.
    			    Invoke DestroyWindow, hCboDD
                    Invoke SetFocus, [ebx+EBDATA.hParent]
                    ret
    			.ENDIF	  		    
    		.ENDIF        
			mov eax,[ebx+EBDATA.iItem]
			mov lvi.iItem,eax
			mov eax,[ebx+EBDATA.iSubitem]
			mov lvi.iSubItem,eax
			mov lvi.imask,LVIF_TEXT
			lea eax, szTextBuffer
			mov lvi.pszText, eax
			invoke SendMessage,[ebx+EBDATA.hParent],LVM_SETITEMTEXT,[ebx+EBDATA.iItem], Addr lvi
            Invoke DestroyWindow, hCboDD
            Invoke SetFocus, [ebx+EBDATA.hParent] ; force focus to listview itself to allow us to quit out of combo
            ret
            
        .ELSEIF wParam == VK_RETURN
    		invoke GetWindowLong,hWin,GWL_USERDATA
    		mov ebx,eax
    		Invoke SendMessage, hCboDD, CB_GETDROPPEDSTATE, 0, 0 ; Check if list is open
			.IF eax == FALSE
			    Invoke SendMessage, hWin, WM_GETTEXT, MAX_PATH, Addr szTextBuffer  ; if its not just get text from editbox
            .ELSE
                invoke SendMessage,hCboDD,CB_GETCURSEL,0,0 ; otherwise get current selection from opened listbox
    			.IF eax != CB_ERR
    			    mov ecx, eax
    				invoke SendMessage,hCboDD,CB_GETLBTEXT, ecx, Addr szTextBuffer
    			.ELSE ; if for some reason no selection is made in open listbox assume its like escape/cancel - so just do that instead.
    			    Invoke DestroyWindow, hCboDD
                    Invoke SetFocus, [ebx+EBDATA.hParent]
                    ret
    			.ENDIF	  		    
    		.ENDIF        			    
			mov eax,[ebx+EBDATA.iItem]
			mov lvi.iItem,eax
			mov eax,[ebx+EBDATA.iSubitem]
			mov lvi.iSubItem,eax
			mov lvi.imask,LVIF_TEXT
			lea eax, szTextBuffer
			mov lvi.pszText, eax
			invoke SendMessage,[ebx+EBDATA.hParent],LVM_SETITEMTEXT,[ebx+EBDATA.iItem], Addr lvi
            Invoke DestroyWindow, hCboDD
            Invoke SetFocus, [ebx+EBDATA.hParent] ; force focus to listview itself to allow us to quit out of combo
            ret
        .ELSE
	        invoke GetWindowLong, hWin, GWL_USERDATA
	        invoke CallWindowProc, [eax+EBDATA.pOldProc], hWin, uMsg, wParam, lParam            
        .ENDIF        

	.ELSE
	    invoke GetWindowLong, hWin, GWL_USERDATA
	    invoke CallWindowProc, [eax+EBDATA.pOldProc], hWin, uMsg, wParam, lParam        
    .ENDIF
    ret
ListViewDropDownEditProc    ENDP

